
#ifndef __SERVER_HPP__
#define __SERVER_HPP__

#include <yarp/os/all.h>

#include <string>
#include <list>


class CollatzServerProcessor : public yarp::os::PortReader,
                               public yarp::os::RateThread
{
protected:
    std::list<unsigned int> table;
    yarp::os::Semaphore *mutex;
    unsigned int curNum;

    void tickItem(const unsigned int num);
    void generateItem(unsigned int &num, unsigned int &thres);
    void dumpTable();

    virtual bool read(yarp::os::ConnectionReader& connection);
    virtual void run();

public:
    CollatzServerProcessor(const unsigned int dumpPeriod);
    virtual ~CollatzServerProcessor();
};


#endif

